C Initializes all the variables and pass the values through commons
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C-----------------------------------------------------------------------
      subroutine INIAITALC(
     &     sqrtsmaninput,       !center of mass energy
     &     costinput           !cos(theta) for scattering angle
     &     )
C *** This soubroutine should run everytime a new center of mass energy
C (sqrtsman) or scattering angle (cost) is set.

      implicit none

      double precision sqrtsmaninput,costinput
      double precision lastsqrtsman,lastcost
      logical
     &     lrenorminput,        !renormalization flag .true./.false.
     &     lwidthinput,         !propagator's widths .true./.false.
     &     lidentCKMinput,      !Identity for CKM matrix .true./.false. 
     &     luvcheckinput,       !UV-check flag
     &     lircheckinput        !UV-check flag
      common /lflags/ lrenorminput,lwidthinput,lidentCKMinput
     &     ,luvcheckinput,lircheckinput

      logical linitialize
      integer i1,i2
#include <parameterlist.hf>
#include <variablelist.hf>
#include <looptools.h>
      data sqrtsman /-1d0/, cost /-2d0/
      data mudim, musq, delta, maxdev /1d3,1d0,1d0,1d-6/
      data MMAsoft /1d0/
      data VCKM /Vud,Vcd,Vtd,Vus,Vcs,Vts,Vub,Vcb,Vtb/
      data wfac1,wfac2 /1,1/
      save linitialize
C
c      print *,'data mudim, musq, delta, maxdev /1d100,1d0,5d3,1d-6/'
c      print *, mudim, musq, delta, maxdev
c      print *,'data MMAsoft /1d0/'
c      print *,MMAsoft
c      stop
C-----------------------------------------------------------------------
C Checking whether the ini has already run once
      if (linitialize) then
        goto 10
      else
        print *,"Initializing aITALC parameters"
        linitialize = .NOT.linitialize
      endif
C-----------------------------------------------------------------------
C This seems absurd, but reconciliates input and output
      if (sqrtsmaninput.LE.0d0) then
        print *,'iniaitalc: sqrt(s) <= 0, stop'
        stop
      elseif ((costinput.GT.1d0).OR.(costinput.LT.-1d0)) then
        print *,'iniaitalc: cost out of limits, stop'
        stop
      endif
C-----------------------------------------------------------------------
C LoopTools/FF STUFF
      call ffini
      call setmudim(1d0)
      call setdelta(0d0)
c      call hhini
CC Some LoopTools and Loopfunctions tests
      if (luvcheckinput) then
        call setdelta(delta)
        call setmudim(mudim)
        musq=mudim
        print *,'UV parameter mu^2  set to',getmudim()
        print *,'UV parameter 1/eps set to',getdelta()
      endif
      if (lircheckinput) then 
        MMAsoft=DEXP(1d0)
        call setlambda(MMAsoft) !For the LoopTools package
        print *,'IR parameter lambda set to',getlambda()
      endif
      lambda2=MMAsoft           !For the /ffcut/ in FF package
c      call setmaxdev(maxdev)     ! When calling -looptools_check
C-----------------------------------------------------------------------
C Begin of mathematical constants
      pi=numberpi
      zero=numberzero
      conversion=conhc
      im=numberim
C Physical constants
      sw=DSQRT(sw2)
      cw=DSQRT(cw2)
      e=DSQRT(4*pi/alphai)
C-----------------------------------------------------------------------
C Beginning of boson properties declaration, masses, squared, inverse
      MW=massW
      MA=massA
      MZ=massZ
      MH=massH

      MMW=MW**2
      MMA=MA**2
      MMZ=MZ**2
      MMH=MH**2

      cMMW= MMW
      cMMA= MMA
      cMMZ= MMZ
      cMMH= MMH

C End of boson properties declaration
C-----------------------------------------------------------------------
C Beginning of fermion properties declaration, masses, squared, quantums
      Mne=massne
      Mnm=massnm
      Mnt=massnt
      Mle=massle
      Mlm=masslm
      Mlt=masslt
      Mu=massu
      Mc=massc
      Mt=masst
      Md=massd
      Ms=masss
      Mb=massb

      MMne=Mne*Mne
      MMnm=Mnm*Mnm
      MMnt=Mnt*Mnt
      MMle=Mle*Mle
      MMlm=Mlm*Mlm
      MMlt=Mlt*Mlt
      MMu=Mu*Mu
      MMc=Mc*Mc
      MMt=Mt*Mt
      MMd=Md*Md
      MMs=Ms*Ms
      MMb=Mb*Mb
C Complex values are required for loops
      cMMne=Mne*Mne
      cMMnm=Mnm*Mnm
      cMMnt=Mnt*Mnt
      cMMle=Mle*Mle
      cMMlm=Mlm*Mlm
      cMMlt=Mlt*Mlt
      cMMu=Mu*Mu
      cMMc=Mc*Mc
      cMMt=Mt*Mt
      cMMd=Md*Md
      cMMs=Ms*Ms
      cMMb=Mb*Mb

      Qne=  0d0
      Qnm=  0d0
      Qnt=  0d0
      Qle=  - 1.D0
      Qlm=  - 1.D0
      Qlt=  - 1.D0
      Qu= 2.D0/3.D0
      Qc= 2.D0/3.D0
      Qt= 2.D0/3.D0
      Qd=  - 1.D0/3.D0
      Qs=  - 1.D0/3.D0
      Qb=  - 1.D0/3.D0
      
      I3ne= 1.D0/2.D0
      I3nm= 1.D0/2.D0
      I3nt= 1.D0/2.D0
      I3le=  - 1.D0/2.D0
      I3lm=  - 1.D0/2.D0
      I3lt=  - 1.D0/2.D0
      I3u= 1.D0/2.D0
      I3c= 1.D0/2.D0
      I3t= 1.D0/2.D0
      I3d=  - 1.D0/2.D0
      I3s=  - 1.D0/2.D0
      I3b=  - 1.D0/2.D0
      
      GVne= 1.D0/4.D0/sw/cw
      GVnm= 1.D0/4.D0/sw/cw
      GVnt= 1.D0/4.D0/sw/cw
      GVle= sw/cw - 1.D0/4.D0/sw/cw
      GVlm= sw/cw - 1.D0/4.D0/sw/cw
      GVlt= sw/cw - 1.D0/4.D0/sw/cw
      GVu=  - 2.D0/3.D0*sw/cw + 1.D0/4.D0/sw/cw
      GVc=  - 2.D0/3.D0*sw/cw + 1.D0/4.D0/sw/cw
      GVt=  - 2.D0/3.D0*sw/cw + 1.D0/4.D0/sw/cw
      GVd= 1.D0/3.D0*sw/cw - 1.D0/4.D0/sw/cw
      GVs= 1.D0/3.D0*sw/cw - 1.D0/4.D0/sw/cw
      GVb= 1.D0/3.D0*sw/cw - 1.D0/4.D0/sw/cw
      
      GAne= 1.D0/4.D0/sw/cw
      GAnm= 1.D0/4.D0/sw/cw
      GAnt= 1.D0/4.D0/sw/cw
      GAle=  - 1.D0/4.D0/sw/cw
      GAlm=  - 1.D0/4.D0/sw/cw
      GAlt=  - 1.D0/4.D0/sw/cw
      GAu= 1.D0/4.D0/sw/cw
      GAc= 1.D0/4.D0/sw/cw
      GAt= 1.D0/4.D0/sw/cw
      GAd=  - 1.D0/4.D0/sw/cw
      GAs=  - 1.D0/4.D0/sw/cw
      GAb=  - 1.D0/4.D0/sw/cw
C-----------------------------------------------------------------------
C Value set of the CKM matrix elements

      c12=DSQRT(1-s12**2)
      c13=DSQRT(1-s13**2)
      c23=DSQRT(1-s23**2)

      CKM(1,1)= c12*c13
      CKM(1,2)= s12*c13
      CKM(1,3)= s13*EXP(-im*delta13)
      CKM(2,1)=-s12*c23-c12*s23*s13*EXP(im*delta13)
      CKM(2,2)= c12*c23-s12*s23*s13*EXP(im*delta13)
      CKM(2,3)= s23*c13
      CKM(3,1)= s12*s23-c12*c23*s13*EXP(im*delta13)
      CKM(3,2)=-c12*s23-s12*c23*s13*EXP(im*delta13)
      CKM(3,3)= c23*c13

      do i2=1,3
        do i1=1,3
c          print *,'CKM,VCKM=',i1,i2,CKM(i1,i2),VCKM(i1,i2)
          if (lidentCKMinput) CKM(i1,i2)=VCKM(i1,i2) !Identity matrix
          CKMD(i1,i2)=DCONJG(CKM(i1,i2))
        enddo
      enddo
*#define CKMDEBUG 1
#ifdef CKMDEBUG
      print *,'TEST CKM=',CKM(3,1)*CKMD(3,1)+CKM(3,2)*CKMD(3,2)+CKM(3,3)
     &     *CKMD(3,3)
      print *,'TEST CKM=',CKM(3,1)*CKMD(2,1)+CKM(3,2)*CKMD(2,2)+CKM(3,3)
     &     *CKMD(2,3)
      print *,'TEST CKM=',CKM(3,1)*CKMD(1,1)+CKM(3,2)*CKMD(1,2)+CKM(3,3)
     &     *CKMD(1,3)

      print *,'TEST CKM=',CKM(2,1)*CKMD(3,1)+CKM(2,2)*CKMD(3,2)+CKM(2,3)
     &     *CKMD(3,3)
      print *,'TEST CKM=',CKM(2,1)*CKMD(2,1)+CKM(2,2)*CKMD(2,2)+CKM(2,3)
     &     *CKMD(2,3)
      print *,'TEST CKM=',CKM(2,1)*CKMD(1,1)+CKM(2,2)*CKMD(1,2)+CKM(2,3)
     &     *CKMD(1,3)

      print *,'TEST CKM=',CKM(1,1)*CKMD(3,1)+CKM(1,2)*CKMD(3,2)+CKM(1,3)
     &     *CKMD(3,3)
      print *,'TEST CKM=',CKM(1,1)*CKMD(2,1)+CKM(1,2)*CKMD(2,2)+CKM(1,3)
     &     *CKMD(2,3)
      print *,'TEST CKM=',CKM(1,1)*CKMD(1,1)+CKM(1,2)*CKMD(1,2)+CKM(1,3)
     &     *CKMD(1,3)
#endif
C-----------------------------------------------------------------------
C Beginning of calculation of renormalization constants and parameters
      call renormalization(lrenorminput)
      call renormalization_QED(lrenorminput)
C End of renormalization
C-----------------------------------------------------------------------
C In case of different energy or angle it comes here
 10   continue
C-----------------------------------------------------------------------
C Beginning of Mandelstann variable set up.
C here initial fermion masses are neglected.
      sqrtsman=sqrtsmaninput
      cost=costinput

      sman=sqrtsman**2
      CALL MANDELSTAM(tman,uman)

      MANDARRAY(1,2)=sman
      MANDARRAY(1,3)=tman
      MANDARRAY(1,4)=uman
      MANDARRAY(2,1)=MANDARRAY(1,2)
      MANDARRAY(2,3)=uman
      MANDARRAY(2,4)=tman
      MANDARRAY(3,1)=MANDARRAY(1,3)
      MANDARRAY(3,2)=MANDARRAY(2,3)
      MANDARRAY(3,4)=sman
      MANDARRAY(4,1)=MANDARRAY(1,4)
      MANDARRAY(4,2)=MANDARRAY(2,4)
      MANDARRAY(4,3)=MANDARRAY(3,4)
C End of mandelstann stuff
C-----------------------------------------------------------------------
C Fixed-width scheme for boson width declaration
      if (lwidthinput) then
        wfac1=1                 !Try to keep single selfenergies
        wfac2=0                 !Double propagators

C Probably, we have also to include the 34 MeV difference at pole mass.
        cMMW = MMW - im*MW*widthW
        cMMZ = MMZ - im*MZ*widthZ
        cMMH = MMH - im*MH*widthH
      endif
C-----------------------------------------------------------------------
C Setting the value of our integrals through /loopvalues/ common
      call LoopIntegrals()
C-----------------------------------------------------------------------
C Deleting cache for Looptools functions
      call setcachelast(Ccache,0)
      call setcachelast(Dcache,0)
c      call setcachelast(CCcache,0)
c      call setcachelast(CDcache,0)
C End of cache
C-----------------------------------------------------------------------
      return
      end
CC $Id: iniaitalc.F,v 1.24 2004/10/13 12:53:35 alorca Exp $
